s = 2;

%% TABLE1
t0 = find(dates>=1920,1,'first'); 
PD(1,:,1) = P(1,:,1)./D(1,:,1);
%[1200*mean(dlogP(t0:end)) 1200*std(dlogP(t0:end)) 1200*mean(dlogD(t0:end)) 1200*std(dlogD(t0:end)) mean(PD(t0:end)/12) std(PD(t0:end)/12)]'
t1 = find(dates>=1990,1,'first'); 
[1200*mean(dlogP(t0:t1)) 1200*std(dlogP(t0:t1)) 1200*mean(dlogD(t0:t1)) 1200*std(dlogD(t0:t1)) mean(PD(t0:t1)/12) std(PD(t0:t1))/12]'

%% FIGURE 1
t=950;
figure(1)
subplot(211)
[P_ord,index] = sort(beta*phi*(exp(mD(:,t,n))*D(1,t,n)+exp(mP(:,t,n))*P(1,t,n)),'descend');
plot(P_ord/PREE(1,t,n), 'Linewidth',2)
hold on
plot(P(1,t,n)/PREE(1,t,n)*ones(size(P_ord)),'c-', 'Linewidth',2)
axis 'tight'
legend('Reservation prices in descending order','Equilibrium price','Location','Best')
%legend 'boxoff'
xlabel('Cohorts ordered by descending reservation price','interpreter','latex','FontSize',14)
ylabel('Asset Price / REE Price','interpreter','latex','FontSize',14)
subplot(212)
PDH = lambda(t);
plot(PDH * D(1,t,n) /P(1,t,n) *cumsum(ff(index,1,n))/sum(ff(:,1,n)), 'Linewidth',2);
hold on
plot(ones(size(P_ord)),'c-', 'Linewidth',2)
xlabel('Cohorts ordered by descending reservation price','FontSize',14,'interpreter','latex')
ylabel('Cumulative asset demand','FontSize',14,'interpreter','latex')
legend('Cumulative asset demand','Asset supply','Location','Best')
%legend 'boxoff'
axis 'tight'
%% FIGURES 2 & 4
dates(1)   = 1990;
dates(end) = 2014.5;
figure(2)
plot(dates,PD/12,'LineWidth',2)
hold on
plot(dates,PDd,'g-','LineWidth',2)
plot(dates,PDREE/12*ones(size(dates)),'k-.','LineWidth',1.5)
ylabel('Price-dividend ratio','FontSize',14,'interpreter','latex')
legend('Model HA-OLG','Data','REE','Location','NorthEast')
xlabel('year','interpreter','latex','FontSize',14)
%legend boxoff
ylim([0 100])
xlim([dates(1) dates(end)])
%xlim([1920 2014.5])

%% FIGURE 3
figure(3)
hold on
for s=[2 5 10 25 50 100 300 500  S]
plot(dates,mP(s,:,n),'Color',[0 (S-s)/S (S-s)/S]);
end
%axis([1 570 0.8 1.3])
%title('Expectations of price growth: darker color indicates older cohort','interpreter','latex','FontSize',14)
xlim([dates(1) 2014.5])
xlabel('year','interpreter','latex','FontSize',14)
ylabel('Expectations of price growth','interpreter','latex','FontSize',14)

%% FIGURE 5
%--------------------------------
% figure (5)
% subplot(221)
% t0 = find(dates>=1920,1,'first'); 
%  
% for i=1:N
%     errorP(1:S,:,i)      = ones(S,1)*dlogP(1,t0:T,i) - mP(1:S,t0-1:T-1,i);
%     errorPREE(1,:,i)     = log(PREE(1,t0:T,i)./PREE(1,t0-1:T-1,i)) - mu;
% end
% 
% plot(mean(mean(errorP(:,:,:),2),3),'Linewidth',2)
% hold on
% plot(ones(S,1)*mean(mean(errorPREE(1,:,:)),3),'c','Linewidth',2)
% legend('HA-OLG','REE', 'Location','Best')
% 
% title('Mean error: Prices','interpreter','latex','FontSize',14)
% % legend 'boxoff'
% axis([0 S -0.01 0.01])
% 
% subplot(223)
% std_errorP    = zeros(S,1,N);
% std_errorPREE = zeros(1,1,N);
% for i=1:N
%     std_errorP(:,1,i)    =  std(errorP(:,:,i)');
%     std_errorPREE(1,1,i) = std(errorPREE(1,:,i));
% end
% 
% plot(mean(std_errorP(:,1,:),3),'Linewidth',2)
% hold on
% plot(ones(S,1)*mean(std_errorPREE(1,1,:),3),'c','Linewidth',2)
% % legend('HA-OLG','REE', 'Location','Best')
% xlabel('Age cohort','interpreter','latex','FontSize',14)
% title('RMSE: Prices','interpreter','latex','FontSize',14)
% % legend 'boxoff'
% axis([0 S 0.0 0.04])
% 
% subplot(222)
% for i=1:N
%     errorD(1:S,:,i)     = ones(S,1)*log(D(1,t0:T,i)./D(1,t0-1:T-1,i)) - mD(1:S,t0-1:T-1,i);
%     errorDREE(1,:,i) =log(D(1,t0:T,i)./D(1,t0-1:T-1,i)) - mu;
% end
% 
% plot(mean(mean(errorD(:,:,:),2),3),'Linewidth',2)
% hold on
% plot(ones(S,1)*mean(mean(errorDREE(1,:,:)),3),'c','Linewidth',2)
% % legend('HA-OLG','REE', 'Location','Best')
% title('Mean error: Dividends','interpreter','latex','FontSize',14)
% % legend 'boxoff'
% axis([0 S -0.01 0.01])
% 
% subplot(224)
% std_errorD    = zeros(S,1,N);
% std_errorDREE = zeros(1,1,N);
% for i=1:N
%     std_errorD(:,1,i)    =  std(errorD(:,:,i)');
%     std_errorDREE(1,1,i) =  std(errorDREE(1,:,i));
% end
% 
% plot(mean(std_errorD(:,1,:),3),'Linewidth',2)
% hold on
% plot(ones(S,1)*mean(std_errorDREE(1,1,:),3),'c','Linewidth',2)
% % legend('HA-OLG','REE', 'Location','Best')
% xlabel('Age cohort','interpreter','latex','FontSize',14)
% title('RMSE: Dividends','interpreter','latex','FontSize',14)
% % legend 'boxoff'
% axis([0 S 0.0 0.04])


%% Figure 6 RA-CGL SOLUTION OPEN LOOP
 
aux1 = 0;
for s =1:floor(theta)
    aux1 = aux1+ phi^s * (1-theta/s);
end
gammaCGL = (1-phi) *(-theta *log(1-phi) + aux1);
 
   % Update of the beliefs
n=1;
mD_CGL = zeros(1,T,N);        %mD RA-CGL
mP_CGL = zeros(1,T,N);        %mP RA-CGL
mD_CGL(1,1,:) = mu;
mP_CGL(1,1,:) = mu;


    for t=2:T
        mD_CGL(1,t,n) = mD_CGL(1,t-1,n) + gammaCGL * (dlogD(1,t,n) - mD_CGL(1,t-1,n));
        mP_CGL(1,t,n) = mP_CGL(1,t-1,n) + gammaCGL * (dlogP(1,t,n) - mP_CGL(1,t-1,n));
    end

    xiD(1,:,n) = mD_av(1,:,n)-mD_CGL(1,:,n);
    xiP(1,:,n) = mP_av(1,:,n)-mP_CGL(1,:,n);

figure(6)
subplot(211)
plot(dates(t0:end),100*mP_CGL(1,t0:end,n),'Linewidth',2)
hold on
plot(dates(t0:end),100*mP_av(1,t0:end,n),'c','Linewidth',2)
title('Expectations of price growth $m^P_t$','interpreter','latex','FontSize',14)
ylabel('%')
xlim([1920 dates(end)])
subplot(212)
plot(dates(t0:end),100*mD_CGL(1,t0:end,n),'Linewidth',2)
hold on
plot(dates(t0:end),100*mD_av(1,t0:end,n),'c','Linewidth',2)
title('Expectations of dividend growth $m^D_t$','interpreter','latex','FontSize',14)
legend('RA-CGL','HA-OLG') 
ylabel('%')
xlabel('Year','interpreter','latex','FontSize',14)
xlim([1920 dates(end)])

%% FIGURE 7 %RA-CGL SOLUTION CLOSED LOOP
aux1 = 0;
for s =1:floor(theta)
    aux1 = aux1+ phi^s * (1-theta/s);
end
gammaCGL = (1-phi) *(-theta *log(1-phi) + aux1);
%gammaCGL = 0.018/3;

n=1
mD_CGL = zeros(1,T,N);        %mD RA-CGL
mP_CGL = zeros(1,T,N);        %mP RA-CGL
mD_CGL(1,1:2,n) = mu;
mP_CGL(1,1:2,n) = mu;
dlogP_CGL = zeros(1,T,N);     % growth rate of prices  
dlogP_CGL(1,1:2,n) = mu;
P_CGL = zeros(1,T,N);         %Prices in the CGL approximation
P_CGL(1,1,n) = P(1,1,n);
P_CGL(1,2,n) = P_CGL(1,1,n)*exp(dlogP_CGL(1,2,n));

for t=3:T
    mD_CGL(1,t,n) = mD_CGL(1,t-1,n) + gammaCGL * (dlogD(1,t,n)       - mD_CGL(1,t-1,n));
    mP_CGL(1,t,n) = mP_CGL(1,t-1,n) + gammaCGL * (dlogP_CGL(1,t-1,n) - mP_CGL(1,t-2,n));
    
    P_CGL(1,t,n) = min(beta* phi * (P_CGL(1,t-1,n) * exp(2*mP_CGL(1,t,n)) + D(1,t,n) * exp(mD_CGL(1,t,n))),lambda(t)*D(1,t,n));
    dlogP_CGL(1,t,n) = log(P_CGL(1,t,n)./P_CGL(1,t-1,n));
    
end

PD_CGL = P_CGL ./D;

dates(1)   = 1920;
dates(end) = 2014.5;
figure(7)
plot(dates,PD/12,'b--','LineWidth',2)
hold on
plot(dates,PDd,'g:','LineWidth',2)
plot(dates,PD_CGL/12,'r-','LineWidth',1.5)
ylabel('Price-dividend ratio','FontSize',14,'interpreter','latex')
%legend('HA-OLG','Data','RA-CGL', 'RA-CGL, \gamma = 0.006','Location','NorthEast')
xlabel('year','interpreter','latex','FontSize',14)
%legend boxoff
ylim([0 100])
xlim([dates(1) dates(end)])
%xlim([1920 2014.5])

dates = (1871+1/24):(1/12):2014.47;
t0 = find(dates>=1920,1,'first'); 

[1200*mean(dlogP_CGL(t0:end)) 1200*std(dlogP_CGL(t0:end)) 1200*mean(dlogD(t0:end)) 1200*std(dlogD(t0:end)) mean(PD_CGL(t0:end)/12) std(PD_CGL(t0:end)/12)]'
t1 = find(dates>=1990,1,'first'); 
[1200*mean(dlogP_CGL(t0:t1)) 1200*std(dlogP_CGL(t0:t1)) 1200*mean(dlogD(t0:t1)) 1200*std(dlogD(t0:t1)) mean(PD_CGL(t0:t1)/12) std(PD_CGL(t0:t1)/12)]'


%% AUXILIAR 
% 
for t=1:T
    SIGMAp(t) = max(abs(mP(:,t,1)));
    SIGMAd(t) = max(abs(mD(:,t,1)));
end
    
SIGMApp =max(SIGMAp(1:end));
SIGMAdd =max(SIGMAd(1:end));

% 
% figure(7)
% subplot(211)
% plot(dates(t0:end),100*xiP(1,t0:end,n),'Linewidth',2)
% hold on
% plot(dates(t0:end),100* ((1-phi)*mu+(phi+gammaCGL-1)*(mP_av(1,t0-1:end-1,n))),'c','Linewidth',2)
% plot(dates(t0:end),100* ((1-phi)*mu+(phi+gammaCGL-1)*(mP_av(1,t0-1:end-1,n))+gammaCGL*SIGMApp),'k:','Linewidth',2)
% plot(dates(t0:end),100* ((1-phi)*mu+(phi+gammaCGL-1)*(mP_av(1,t0-1:end-1,n))-gammaCGL*SIGMApp),'K:','Linewidth',2)
% title('Expectations of price growth $m^P_t$','interpreter','latex','FontSize',14)
% ylabel('%')
% xlim([1920 dates(end)])
% subplot(212)
% plot(dates(t0:end),100*xiD(1,t0:end,n),'Linewidth',2)
% hold on
% plot(dates(t0:end),100* ((1-phi)*mu+(phi+gammaCGL-1)*(mD_av(1,t0-1:end-1,n))),'c','Linewidth',2)
% title('Expectations of dividend growth $m^D_t$','interpreter','latex','FontSize',14)
% %legend('\xi','(1-\phi)(m_0 - m_{t-1})') 
% plot(dates(t0:end),100* ((1-phi)*mu+(phi+gammaCGL-1)*(mD_av(1,t0-1:end-1,n))+gammaCGL*SIGMAdd),'k:','Linewidth',2)
% plot(dates(t0:end),100* ((1-phi)*mu+(phi+gammaCGL-1)*(mD_av(1,t0-1:end-1,n))-gammaCGL*SIGMAdd),'K:','Linewidth',2)
% ylabel('%')
% xlabel('Year','interpreter','latex','FontSize',14)
% xlim([1920 dates(end)])
% 
% 
% for t=2:T
% xiS(t)= phi^s * 1 * mu;
% 
% for s = 2:S
%     xiS(t) = xiS(t)+ phi^s * theta/s * mP(s-1,t,1);
% end
% 
% xiS(t) = (1-phi)*mu+(gammaCGL+phi-1)*mP_av(1,t-1,n)+ (1-phi)*xiS(t);
% 
% end
% 
% figure
% plot(dates(t0:end),100*xiP(1,t0:end,n),'Linewidth',2)
% hold on
% plot(dates(t0:end),100*xiD(1,t0:end,n),'c','Linewidth',2)


